Index: /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Operators/CleanupOperator.cs
===================================================================
--- /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Operators/CleanupOperator.cs	(revision 9237)
+++ /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Operators/CleanupOperator.cs	(revision 9238)
@@ -20,7 +20,10 @@
 #endregion
 
+using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
 using HeuristicLab.Operators;
 using HeuristicLab.Optimization;
@@ -47,5 +50,8 @@
     private const string MaximumGenerationsParameterName = "MaximumGenerations";
     private const string ResultsParameterName = "Results";
-    private const string DeleteGenealogyGraphParameterName = "DeleteGenealogyGraph";
+    private const string CleanGenealogyGraphParameterName = "CleanGenealogyGraph";
+    private const string UpdateGenealogyGraphParameterName = "UpdateGenealogyGraph";
+    private const string SymbolicExpressionTreeParameterName = "SymbolicExpressionTree";
+    private const string SymbolicExpressionTreeQualityParameterName = "Quality";
     #endregion
 
@@ -72,31 +78,30 @@
       get { return (LookupParameter<ResultCollection>)Parameters[ResultsParameterName]; }
     }
-    public ValueParameter<BoolValue> DeleteGenealogyGraphParameter {
-      get { return (ValueParameter<BoolValue>)Parameters[DeleteGenealogyGraphParameterName]; }
+    public ValueParameter<BoolValue> CleanGenealogyGraphParameter {
+      get { return (ValueParameter<BoolValue>)Parameters[CleanGenealogyGraphParameterName]; }
+    }
+    public ValueParameter<BoolValue> UpdateGenealogyGraphParameter {
+      get { return (ValueParameter<BoolValue>)Parameters[UpdateGenealogyGraphParameterName]; }
+    }
+    public IScopeTreeLookupParameter<ISymbolicExpressionTree> SymbolicExpressionTreeParameter {
+      get { return (IScopeTreeLookupParameter<ISymbolicExpressionTree>)Parameters[SymbolicExpressionTreeParameterName]; }
+    }
+    public IScopeTreeLookupParameter<DoubleValue> SymbolicExpressionTreeQualityParameter {
+      get { return (IScopeTreeLookupParameter<DoubleValue>)Parameters[SymbolicExpressionTreeQualityParameterName]; }
     }
     #endregion
 
     #region Properties
-    public CloneMapType GlobalCloneMap {
-      get { return GlobalCloneMapParameter.ActualValue; }
-    }
-    public TraceMapType GlobalTraceMap {
-      get { return GlobalTraceMapParameter.ActualValue; }
-    }
-    public CloneMapType GlobalFragmentMap {
-      get { return GlobalFragmentMapParameter.ActualValue; }
-    }
-    public GeneticExchangeMapType GlobalGeneticExchangeMap {
-      get { return GlobalGeneticExchangeMapParameter.ActualValue; }
-    }
-    public IntValue Generations {
-      get { return GenerationsParameter.ActualValue; }
-    }
-    public IntValue MaximumGenerations {
-      get { return MaximumGenerationsParameter.ActualValue; }
-    }
-    public ResultCollection Results {
-      get { return ResultsParameter.ActualValue; }
-    }
+    private CloneMapType GlobalCloneMap { get { return GlobalCloneMapParameter.ActualValue; } }
+    private TraceMapType GlobalTraceMap { get { return GlobalTraceMapParameter.ActualValue; } }
+    private CloneMapType GlobalFragmentMap { get { return GlobalFragmentMapParameter.ActualValue; } }
+    private GeneticExchangeMapType GlobalGeneticExchangeMap { get { return GlobalGeneticExchangeMapParameter.ActualValue; } }
+    private IntValue Generations { get { return GenerationsParameter.ActualValue; } }
+    private IntValue MaximumGenerations { get { return MaximumGenerationsParameter.ActualValue; } }
+    private ResultCollection Results { get { return ResultsParameter.ActualValue; } }
+    public BoolValue CleanGenealogyGraph { get { return CleanGenealogyGraphParameter.Value; } }
+    public BoolValue UpdateGenealogyGraph { get { return UpdateGenealogyGraphParameter.Value; } }
+    private IEnumerable<DoubleValue> Quality { get { return SymbolicExpressionTreeQualityParameter.ActualValue; } }
+    private IEnumerable<ISymbolicExpressionTree> SymbolicExpressionTree { get { return SymbolicExpressionTreeParameter.ActualValue; } }
     #endregion
 
@@ -105,4 +110,12 @@
       if (!Parameters.ContainsKey(GlobalGeneticExchangeMapParameterName))
         Parameters.Add(new LookupParameter<GeneticExchangeMapType>(GlobalGeneticExchangeMapParameterName));
+      if (!Parameters.ContainsKey(CleanGenealogyGraphParameterName))
+        Parameters.Add(new ValueParameter<BoolValue>(CleanGenealogyGraphParameterName));
+      if (!Parameters.ContainsKey(UpdateGenealogyGraphParameterName))
+        Parameters.Add(new ValueParameter<BoolValue>(UpdateGenealogyGraphParameterName));
+      if (!Parameters.ContainsKey(SymbolicExpressionTreeParameterName))
+        Parameters.Add(new ScopeTreeLookupParameter<ISymbolicExpressionTree>(SymbolicExpressionTreeParameterName, "The symbolic expression trees to analyze."));
+      if (!Parameters.ContainsKey(SymbolicExpressionTreeQualityParameterName))
+        Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>(SymbolicExpressionTreeQualityParameterName, "The qualities of the symbolic expression trees"));
     }
 
@@ -121,4 +134,8 @@
       Parameters.Add(new LookupParameter<IntValue>(MaximumGenerationsParameterName));
       Parameters.Add(new ValueLookupParameter<ResultCollection>(ResultsParameterName, "The results collection where the analysis values should be stored."));
+      Parameters.Add(new ValueParameter<BoolValue>(CleanGenealogyGraphParameterName));
+      Parameters.Add(new ValueParameter<BoolValue>(UpdateGenealogyGraphParameterName));
+      Parameters.Add(new ScopeTreeLookupParameter<ISymbolicExpressionTree>(SymbolicExpressionTreeParameterName, "The symbolic expression trees to analyze."));
+      Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>(SymbolicExpressionTreeQualityParameterName, "The qualities of the symbolic expression trees"));
     }
 
@@ -129,12 +146,28 @@
       if (GlobalGeneticExchangeMap != null) GlobalGeneticExchangeMap.Clear();
 
+      if (!Results.ContainsKey(PopulationGraphParameterName)) return base.Apply();
+      var graph = (SymbolicExpressionTreeGenealogyGraph)Results[PopulationGraphParameterName].Value;
+      if (graph == null) return base.Apply();
+
+      if (UpdateGenealogyGraph.Value) {
+        // update vertex qualities if the trees in the scope were optimized by the ConstantOptimizationAnalyzer
+        ISymbolicExpressionTree[] trees = SymbolicExpressionTree.ToArray();
+        double[] qualities = Quality.Select(x => x.Value).ToArray();
+
+        for (int i = 0; i != trees.Length; ++i) {
+          foreach (var graphNode in graph.GetGraphNodes(trees[i])) {
+            graphNode.Quality = qualities[i];
+          }
+        }
+      }
+
       // if we are at the end of the run, then we clear the genealogy graph (to save memory)
-      if (Generations.Value == MaximumGenerations.Value)
-        if (Results.ContainsKey(PopulationGraphParameterName)) {
-          var graph = (SymbolicExpressionTreeGenealogyGraph)Results[PopulationGraphParameterName].Value;
-          Results.Remove(PopulationGraphParameterName);
-          graph.Dispose();
-        }
-
+      if (CleanGenealogyGraph.Value) {
+        if (Generations.Value == MaximumGenerations.Value)
+          if (Results.ContainsKey(PopulationGraphParameterName)) {
+            Results.Remove(PopulationGraphParameterName);
+            graph.Dispose();
+          }
+      }
       return base.Apply();
     }
Index: /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Operators/LineageAggregator.cs
===================================================================
--- /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Operators/LineageAggregator.cs	(revision 9238)
+++ /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Operators/LineageAggregator.cs	(revision 9238)
@@ -0,0 +1,101 @@
+﻿using System;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.EvolutionaryTracking {
+  /// <summary>
+  /// This operator basically aggregates together a scope list of trees in the current generation and the genealogy graph so far
+  /// in a new object that can be used as Content for the InteractiveIndividualHistoryView
+  /// </summary>
+  [StorableClass]
+  public class GenealogyAggregator : SingleSuccessorOperator {
+    private const string PopulationGraphParameterName = "PopulationGraph";
+    private const string LineageExplorerParameterName = "LineageExplorer";
+    private const string ResultsParameterName = "Results";
+    private const string GenerationsParameterName = "Generations";
+    private const string MaximumGenerationsParameterName = "MaximumGenerations";
+
+    private const string SymbolicExpressionTreeParameterName = "SymbolicExpressionTree";
+    private const string SymbolicExpressionTreeQualityParameterName = "Quality";
+
+    #region Parameter properties
+    public IScopeTreeLookupParameter<ISymbolicExpressionTree> SymbolicExpressionTreeParameter {
+      get { return (IScopeTreeLookupParameter<ISymbolicExpressionTree>)Parameters[SymbolicExpressionTreeParameterName]; }
+    }
+    public IScopeTreeLookupParameter<DoubleValue> SymbolicExpressionTreeQualityParameter {
+      get { return (IScopeTreeLookupParameter<DoubleValue>)Parameters[SymbolicExpressionTreeQualityParameterName]; }
+    }
+    public LookupParameter<ResultCollection> ResultsParameter {
+      get { return (LookupParameter<ResultCollection>)Parameters[ResultsParameterName]; }
+    }
+    public LookupParameter<IntValue> GenerationsParameter {
+      get { return (LookupParameter<IntValue>)Parameters[GenerationsParameterName]; }
+    }
+    public LookupParameter<IntValue> MaximumGenerationsParameter {
+      get { return (LookupParameter<IntValue>)Parameters[MaximumGenerationsParameterName]; }
+    }
+    #endregion
+    #region Properties
+    public bool EnabledByDefault {
+      get { return true; }
+    }
+    public ResultCollection Results {
+      get { return ResultsParameter.ActualValue; }
+    }
+    public IntValue Generations {
+      get { return GenerationsParameter.ActualValue; }
+    }
+    public IntValue MaximumGenerations {
+      get { return MaximumGenerationsParameter.ActualValue; }
+    }
+    #endregion
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() { }
+
+    #region IStatefulItem members
+    public override void InitializeState() {
+      base.InitializeState();
+    }
+
+    public override void ClearState() {
+      base.ClearState();
+    }
+    #endregion
+
+    [StorableConstructor]
+    private GenealogyAggregator(bool deserializing) : base(deserializing) { }
+    private GenealogyAggregator(GenealogyAggregator original, Cloner cloner) : base(original, cloner) { }
+    public override IDeepCloneable Clone(Cloner cloner) { return new GenealogyAggregator(this, cloner); }
+    public GenealogyAggregator() {
+      #region Add parameters
+      Parameters.Add(new LookupParameter<IntValue>(GenerationsParameterName, "The number of generations so far."));
+      Parameters.Add(new LookupParameter<IntValue>(MaximumGenerationsParameterName, "The maximum number of generations"));
+      Parameters.Add(new ValueLookupParameter<ResultCollection>(ResultsParameterName, "The results collection where the analysis values should be stored."));
+      Parameters.Add(new ScopeTreeLookupParameter<ISymbolicExpressionTree>(SymbolicExpressionTreeParameterName, "The symbolic expression trees to analyze"));
+      Parameters.Add(new ScopeTreeLookupParameter<DoubleValue>(SymbolicExpressionTreeQualityParameterName, "The qualities of the symbolic expression trees"));
+      #endregion
+    }
+
+    public override IOperation Apply() {
+      if (!Results.ContainsKey(PopulationGraphParameterName)) return base.Apply();
+      var graph = (SymbolicExpressionTreeGenealogyGraph)Results[PopulationGraphParameterName].Value;
+      var trees = SymbolicExpressionTreeParameter.ActualValue;
+      var qualities = SymbolicExpressionTreeQualityParameter.ActualValue;
+      var tuples = trees.Zip(qualities, (t, q) => new Tuple<ISymbolicExpressionTree, double>(t, q.Value)).ToList();
+      var lineageExplorer = new LineageExplorer { GenealogyGraph = graph, Trees = tuples, Generations = Generations.Value };
+      if (!Results.ContainsKey(LineageExplorerParameterName))
+        Results.Add(new Result(LineageExplorerParameterName, lineageExplorer));
+      else Results[LineageExplorerParameterName].Value = lineageExplorer; 
+
+      return base.Apply();
+    }
+  }
+}
Index: /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Operators/SymbolicExpressionTreeGenealogyGraphBuilder.cs
===================================================================
--- /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Operators/SymbolicExpressionTreeGenealogyGraphBuilder.cs	(revision 9237)
+++ /branches/HeuristicLab.EvolutionaryTracking/HeuristicLab.EvolutionaryTracking/3.4/Operators/SymbolicExpressionTreeGenealogyGraphBuilder.cs	(revision 9238)
@@ -21,5 +21,4 @@
 
 using System;
-using System.Collections.Generic;
 using System.Linq;
 using System.Threading;
@@ -63,5 +62,5 @@
     private const string SymbolicExpressionTreeQualityParameterName = "Quality";
     #endregion
-    #region Parameter properties
+    #region Parameters
     public IScopeTreeLookupParameter<ISymbolicExpressionTree> SymbolicExpressionTreeParameter {
       get { return (IScopeTreeLookupParameter<ISymbolicExpressionTree>)Parameters[SymbolicExpressionTreeParameterName]; }
@@ -109,5 +108,5 @@
     }
     #endregion
-    #region Properties
+    #region Parameter properties
     public bool EnabledByDefault {
       get { return true; }
@@ -189,6 +188,4 @@
 
     public override IOperation Apply() {
-      if (GlobalTraceMap == null) return base.Apply(); // no trace map, no genealogy graph
-
       if (!Parameters.ContainsKey("Results")) return base.Apply();
 
@@ -211,17 +208,38 @@
       var pairs = trees.Zip(qualities, (t, q) => new { Tree = t, Quality = q.Value }).OrderByDescending(x => x.Quality).ToList();
 
-      var graphNodes = new List<SymbolicExpressionGenealogyGraphNode>(
-        (from i in Enumerable.Range(0, trees.Length)
-         let tree = pairs[i].Tree
-         let quality = pairs[i].Quality
-         select new SymbolicExpressionGenealogyGraphNode { SymbolicExpressionTree = tree, Quality = quality, Rank = generation, IsElite = i < Elites.Value }
-        ).Concat
-        (from t in trees
-         where GlobalTraceMap.ContainsKey(t)
-         let parents = GlobalTraceMap[t]
-         where parents.Count == 1 // 1 parent means mutation
-         let p = (ISymbolicExpressionTree)parents[0]
-         select new SymbolicExpressionGenealogyGraphNode { SymbolicExpressionTree = p, Quality = Evaluate(p), Rank = generation - 0.5 }
-        )).ToList();
+      if (generation == 0) {
+        // add the trees in the graph and return
+        foreach (var pair in pairs) {
+          var tree = pair.Tree;
+          var quality = pair.Quality;
+          graph.AddNode(new SymbolicExpressionGenealogyGraphNode {
+            SymbolicExpressionTree = tree, Quality = quality, Rank = generation
+          });
+        }
+        return base.Apply();
+      }
+
+      var graphNodes = (from i in Enumerable.Range(0, trees.Length)
+                        let tree = pairs[i].Tree
+                        let quality = pairs[i].Quality
+                        select new SymbolicExpressionGenealogyGraphNode {
+                          SymbolicExpressionTree = tree,
+                          Quality = quality,
+                          Rank = generation,
+                          IsElite = i < Elites.Value
+                        }).Concat
+        // the following query addds the intermediate nodes that were created when 
+        // crossover was followed by mutation (they are not present in the scope) 
+                        (from t in trees
+                         where GlobalTraceMap.ContainsKey(t)
+                         let parents = GlobalTraceMap[t]
+                         where parents.Count == 1 // 1 parent means mutation
+                         let p = (ISymbolicExpressionTree)parents[0]
+                         select new SymbolicExpressionGenealogyGraphNode {
+                           SymbolicExpressionTree = p,
+                           Quality = Evaluate(p),
+                           Rank = generation - 0.5 // an intermediate parent that would normale be 'invisible' to the evolutionary process
+                         }
+                        ).ToList();
 
       foreach (var node in graphNodes) {
@@ -229,13 +247,21 @@
       }
 
+      graphNodes.Sort((a, b) => b.Rank.CompareTo(a.Rank));
+
       foreach (var node in graphNodes) {
         var tree = node.SymbolicExpressionTree;
-        if (!GlobalTraceMap.ContainsKey(tree)) continue;
+        if (!GlobalTraceMap.ContainsKey(tree)) {
+          continue;
+        }
         var parents = GlobalTraceMap[tree].Cast<ISymbolicExpressionTree>();
         foreach (var p in parents) {
           var nodes = graph.GetGraphNodes(p);
-          if (nodes == null) continue;
+          if (nodes == null) {
+            throw new Exception("Node cannot have no parents");
+          }
           var sourceNode = nodes.LastOrDefault(n => n.Rank < node.Rank);
-          if (sourceNode == null) continue;
+          if (sourceNode == null) {
+            throw new Exception("Source node cannot be null");
+          }
           var arc = new Arc { Source = sourceNode, Target = node, Data = GlobalFragmentMap[tree] };
           sourceNode.AddForwardArc(arc);
@@ -249,6 +275,6 @@
     /// Evaluate a symbolic expression tree. We perform evaluation by adding a temporary subscope with the tree in it, and calling evaluator.Apply()
     /// </summary>
-    /// <param name="tree"></param>
-    /// <returns></returns>
+    /// <param name="tree">The symbolic expression tree to evaluate</param>
+    /// <returns>A double value representing the fitness</returns>
     private double Evaluate(IItem tree) {
       var subScope = new Scope();
